m = 1.0;
l = 1.0;
h = l/2;
r = 0.1;

J = 0.25*m*r*r + (1/12)*m*l*l;

p = m*h*h/J;
g = 9.81;
function f = rechteSeite(t,y)
    phi    = y(1,1);
    omega  = y(2,1);
    
    sp = sin(phi);
    cp = cos(phi);
    
    Q = [  (-1-p*cp*cp)  ,  -p*cp*sp  ;
           -p*cp*sp      ,   (-1-p*sp*sp)];
    q = [m*h*omega*omega*sp;  -m*h*omega*omega*cp-m*g]       
    
    F = inv(Q)*q;
    Fx = F(1,1);
    Fy = F(2,1);
    
    f(1,1) = omega;
    f(2,1) = -(h/J)*sin(phi)*Fy - (h/J)*cos(phi)*Fx;
endfunction

function f = rechteSeite2(t,y)
    phi    = y(1,1);
    omega  = y(2,1);
        
    f(1,1) = omega;
    f(2,1) = -(m*g*h/(J+m*h*h))*sin(phi);
endfunction


t = linspace(0,30,3000);
y0 = [%pi*0.25,0]';
t0 = 0;
y  = ode(y0,t0,t,rechteSeite);
y2  = ode(y0,t0,t,rechteSeite2);

plot(t,y(1,:)',t,y(2,:)');
//plot(t,y(1,:)',t,y2(1,:)');
//plot(t,y(1,:)'-y2(1,:)');


fd = mopen('/home/fhbstud/sichern/winkelverlauf.txt','wt');
groesse=size(y);
zeilen=groesse(2);
mfprintf(fd,'DEF DREHUNG OrientationInterpolator\n');
mfprintf(fd,'{\n');
mfprintf(fd,'    #Zeit\n');
mfprintf(fd,'    key\n');
mfprintf(fd,'    [\n');

for i=1:zeilen
   mfprintf(fd,'%f\n',((i-1)/(zeilen-1)));
end

mfprintf(fd,'    ]\n');

mfprintf(fd,' \n');
mfprintf(fd,'    #Drehachse: x y z  Winkel\n');
mfprintf(fd,'    keyValue\n');
mfprintf(fd,'    [\n');

for i=1:zeilen
   mfprintf(fd,'0 0 1 %f\n',y(1,i));
end

mfprintf(fd,'    ]\n');
mfprintf(fd,'}\n');


mclose(fd);






